//addsvgicon  ver.0.01
//(c)Beer[Tsutsumi Hiroyuki]  2013.9.15

#include	<Be.h>

void	help();
void	quit(char *s);

int main(int argc,char **argv)
{
	if(argc<3)help();
	uchar	flag=0;
	char	*ifn=argv[argc-2];
	char	*ofn=argv[argc-1];
	for(int i=1;i<argc-2;i++){
		if(!strcmp(argv[i],"-r"))flag|=1;
		else if(!strcmp(argv[i],"-a"))flag|=2;
		else help();
	}
	if(flag==0)flag=3;

//	printf("read svg/hvif\n");
	BFile	svgf(ifn,B_READ_ONLY);
	off_t	len;
	svgf.GetSize(&len);
	char	*buf=new char[len];
	len=svgf.Read(buf,len);
	if(len==0)quit("cannot read svg");
//	printf("svg/hvif size=%04x\n",len);
	char	icon_d[8];
	sprintf(icon_d,"IDXZ%cS%c",5,0);

	if(flag&1){
//		printf("set resource\n");
		BFile	f(ofn,B_READ_WRITE);
		BResources	r(&f);
		if(strncmp(buf,"ncif",4)){	//svg for zeta
			r.RemoveResource('iICO',101);
			r.RemoveResource('zICO',101);
			if(r.AddResource('iICO',101,icon_d,7,"BEOS:D:STD_ICON"))quit("cannot add resource\n");
			if(r.AddResource('zICO',101,buf,len,"BEOS:V:STD_ICON"))quit("cannot add resource\n");
		}else{						//hvif for haiku
			r.RemoveResource('VICN',101);
			if(r.AddResource('VICN',101,buf,len,"BEOS:ICON"))quit("cannot add resource\n");
		}
	}
	if(flag&2){
//		printf("set attribute\n");
		BNode	n(ofn);
		if(strncmp(buf,"ncif",4)){	//svg for zeta
			if(n.WriteAttr("BEOS:D:STD_ICON",'iICO',0,icon_d,7)!=7)quit("cannot add attribute\n");
			if(n.WriteAttr("BEOS:V:STD_ICON",'zICO',0,buf,len)!=len)quit("cannot add attribute\n");
		}else{						//hvif for haiku
			if(n.WriteAttr("BEOS:ICON",'VICN',0,buf,len)!=len)quit("cannot add attribute\n");
		}
	}
	return(0);
}

void help()
{
	printf("addsvgicon ver.0.01\n");
	printf("addsvgicon [-r] [-a] svg_file|hvif_file target_file\n");
	printf("\t-r: add into resource\n");
	printf("\t-a: add into attribute\n");
	printf("(default is '-r'and'-a'\n");
	exit(0);
}

void quit(char *s)
{
	printf("err: %s\n",s);
	exit(1);
}
